HDU 6319 Problem A. Ascending Rating(单调队列)

Problem A. Ascending Rating

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 524288/524288 K (Java/Others)
Total Submission(s): 3776    Accepted Submission(s): 1246


 

Problem Description

Before the start of contest, there are n ICPC contestants waiting in a long queue. They are labeled by 1 to n from left to right. It can be easily found that the i -th contestant's QodeForces rating is ai .
Little Q, the coach of Quailty Normal University, is bored to just watch them waiting in the queue. He starts to compare the rating of the contestants. He will pick a continous interval with length m , say [l,l+m−1] , and then inspect each contestant from left to right. Initially, he will write down two numbers maxrating=−1 and count=0 . Everytime he meets a contestant k with strictly higher rating than maxrating , he will change maxrating to ak and count to count+1 .
Little T is also a coach waiting for the contest. He knows Little Q is not good at counting, so he is wondering what are the correct final value of maxrating and count . Please write a program to figure out the answer.

 

 

Input

The first line of the input contains an integer T(1≤T≤2000) , denoting the number of test cases.
In each test case, there are 7 integers n,m,k,p,q,r,MOD(1≤m,k≤n≤107,5≤p,q,r,MOD≤109) in the first line, denoting the number of contestants, the length of interval, and the parameters k,p,q,r,MOD .
In the next line, there are k integers a1,a2,...,ak(0≤ai≤109) , denoting the rating of the first k contestants.
To reduce the large input, we will use the following generator. The numbers p,q,r and MOD are given initially. The values ai(k<i≤n) are then produced as follows :

ai=(p×ai−1+q×i+r)modMOD


It is guaranteed that ∑n≤7×107 and ∑k≤2×106 .

 

 

 

Output

Since the output file may be very large, let's denote maxratingi and counti as the result of interval [i,i+m−1] .
For each test case, you need to print a single line containing two integers A and B , where :

AB==∑i=1n−m+1(maxratingi⊕i)∑i=1n−m+1(counti⊕i)


Note that ``⊕ '' denotes binary XOR operation.

 

 

Sample Input

 

1 10 6 10 5 5 5 5 3 2 2 1 5 7 6 8 2 9

 

 

Sample Output

 

46 11

 

 

Source

2018 Multi-University Training Contest 3

 

 

Recommend

chendu   |   We have carefully selected several similar problems for you:  6331 6330 6329 6328 6327 

 

题意:先给一串长度为k的序列,随后需要根据递推式求出长度为n的整个序列。随后从左往右询问每一个区间的最大值以及到达这个最大值进行了几次更新。随后根据式子输出A、B

思路:比赛的时候队友很快看出了是单调队列,但是从左往右找的话找不出如何解决问题。真的没有想到是从后往前单调队列,并且非常简单。从后往前维护一个递减的单调队列的话

#include<cstdio>
#include<cmath>
using namespace std;
typedef long long ll;
const int maxn=1e7+5;
int a[maxn],b[maxn];
int main()
{
    ll A,B;
    int m,k,n,p,q,r,mod;
    int T,i;
    scanf("%d",&T);
    while(T--)
    {
        scanf("%d %d %d %d %d %d %d",&n,&m,&k,&p,&q,&r,&mod);
        for(i=1;i<=k;i++)
            scanf("%d",&a[i]);
        for(i=k+1;i<=n;i++)
            a[i]=(1LL*p*a[i-1]+1LL*q*i+r)%mod;
        A=B=0;
        int h=1,t=0;
        for(i=n;i>0;i--)
        {
            while(h<=t&&a[i]>=a[b[t]])
                t--;
            b[++t]=i;
            if(i+m-1<=n)
            {
                while(b[h]>i+m-1) h++;
                A+=i^a[b[h]];
                B+=i^(t-h+1);
            }
        }
        printf("%lld %lld\n",A,B);
    }
    return 0;
}

,count的值就是队列当中的元素个数了。

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值